# Specs file to building RPM of Linux to DJGPP cross-compiler
# Tested on Fedora Core 4. One may need to modify this file
# for other RPM based Linux distribution
Name: djcross-gcc
Summary:  GCC cross-compiler for target i586-pc-msdosdjgpp
Version: 4.2.1
Release: 9
License: GPL
Group: Development/Tools
URL: http://www.iki.fi/andris.pavenis/djgpp/gcc/cross-compiler
Source0: gcc-%{version}.tar.bz2
Source1: gcc412s2.zip
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch: i686
Requires: djcrx djcross-binutils
BuildPrereq: gcc gcc-gnat gmp gmp-devel djcrx djcross-binutils autoconf >= 2.59 autoconf213 automake >= 1.9.4 automake14

%define shortver %(echo %{version} | sed -e 's:\\.::2g')
%define shortver2 %(echo %{version} | sed -e 's:\\.::g')

%description 
Support of the following programing languages is included:
    C
    C++
    Fortran
    Objective C
    Objective C++
    Ada

%prep 
rm -rf $RPM_BUILD_DIR/%{name}-%{version} || exit 1
mkdir $RPM_BUILD_DIR/%{name}-%{version} || exit 1
ln -s $RPM_SOURCE_DIR/gcc-%{version}.tar.bz2 $RPM_BUILD_DIR/%{name}-%{version}/ || exit 1
cd $RPM_BUILD_DIR/%{name}-%{version} || exit 1
unzip -aq $RPM_SOURCE_DIR/gcc%{shortver2}s2.zip || exit 1
sed -e 's:^\(AUTOCONF_OLD=\).*$:\1/usr/bin/autoconf-2.13:' \
    -e 's:^\(AUTOHEADER_OLD=\).*$:\1/usr/bin/autoheader-2.13:' \
    -e 's:^\(exec .*\)$:#\1:' unpack-gcc.sh >unpack-gcc.sh.new
mv -f unpack-gcc.sh.new unpack-gcc.sh
sh unpack-gcc.sh || exit 1

%build 
# Build requires this directory to be present or to be creatable to work
# properly. Therefore verify that at very begin as this is rather likely
# to cause problems later.
mkdir -p /usr/lib/gcc/i586-pc-msdosdjgpp/%{version} || exit 1
#
cd $RPM_BUILD_DIR/%{name}-%{version}

mkdir tmpbuild || exit 1
cd tmpbuild || exit 1

../gnu/gcc-%{shortver}/configure --prefix=$RPM_BUILD_DIR/%{name}-%{version}/tmpinst \
			  --enable-languages=c,ada \
			  --enable-__cxa_atexit || exit 1
make bootstrap || exit 1
make install || exit 1
export PATH="$RPM_BUILD_DIR/%{name}-%{version}/tmpinst/bin:$PATH"
export LD_LIBRARY_PATH="$RPM_BUILD_DIR/%{name}-%{version}/tmpinst"
cd ..
#
mkdir djcross
cd djcross
gcc -v >$RPM_BUILD_DIR/%{name}-%{version}/gccver.stmp 2>&1
../gnu/gcc-%{shortver}/configure --build=%{_build} \
			  --host=%{_host} \
			  --target=i586-pc-msdosdjgpp \
			  --program-prefix=i586-pc-msdosdjgpp- \
			  --prefix=%{_prefix} \
			  --exec-prefix=%{_exec_prefix} \
			  --bindir=%{_bindir} \
			  --sbindir=%{_sbindir} \
			  --sysconfdir=%{_sysconfdir} \
			  --datadir=%{_datadir} \
			  --includedir=%{_includedir} \
			  --libdir=%{_libdir} \
			  --libexecdir=%{_libexecdir} \
			  --localstatedir=%{_localstatedir} \
			  --sharedstatedir=%{_sharedstatedir} \
			  --mandir=%{_mandir} \
			  --infodir=%{_infodir} \
			  --disable-nls \
			  --enable-version-specific-runtime-libs \
			  --enable-languages=c,c++,f95,objc,obj-c++,ada || exit 1 
make || exit 1

%install 
rm -fr %{buildroot}

export STRIP=/bin/true
cd $RPM_BUILD_DIR/%{name}-%{version}/djcross
%makeinstall
( cd %{buildroot}%{_bindir} && strip -v * )
( cd %{buildroot}%{_bindir} && mv -fv gprmake i586-pc-msdosdjgpp-gprmake )
( cd %{buildroot}%{_bindir} && mv -fv vxaddr2line i586-pc-msdosdjgpp-vxaddr2line )
rm -f %{buildroot}%{_libdir}/libiberty.a
rm -fr %{buildroot}%{_mandir}/man7/*
rm -fr %{buildroot}%{_infodir}/*

( cd %{buildroot}%{_libexecdir}/gcc/i586-pc-msdosdjgpp/%{version} &&\
    strip -v cc1* collect2 f951 gnat1 install-tools/fixincl )

%clean 
rm -fr %{buildroot}

%files 
%defattr(-,root,root) 
%{_bindir}/*
%{_libdir}/gcc/*
%{_libexecdir}/gcc/*
%{_prefix}/i586-pc-msdosdjgpp/*
%{_mandir}/man1/*

%changelog

* Fri Jul 25 2007 Andris Pavenis <andris.pavenis@iki.fi>
- Update to GCC-4.2.1 (4.2.1-9).

* Fri Jul 23 2007 Andris Pavenis <andris.pavenis@iki.fi>
- Small updates not really influencing functionality
  (4.2.0-8).

* Fri Jun 07 2007 Andris Pavenis <andris.pavenis@iki.fi>
- Small updates not really influencing functionality
  (4.2.0-7).

* Mon May 28 2007 Andris Pavenis <andris.pavenis@iki.fi>
- Include patch for fixing warnings about requested
  alignemnt exceeding one supported in object file
  from DJ Delorie <dj@delorie.com> 

* Wed May 23 2007 Andris Pavenis <andris.pavenis@iki.fi>
- Update to GCC-4.2.0 (4.2.0-5)

* Sun Mar 25 2007 Andris Pavenis <andris.pavenis@iki.fi>
- Test for cross-compiler installation directory at very
  begin, as it is nuisance to see build failing after an
  hour for this reason
- Merge changes from Gordon Schumacher with my updates to
  later GCC versions.

* Tue Mar 13 2007 Gordon Schumacher <whiplash@pobox.com>
- Updated to use RPM's prefix macros

* Thu Mar  8 2007 Andris Pavenis <andris.pavenis@iki.fi>
- Update to GCC-4.1.2 (4.1.2-1)
 
* Tue May 30 2006 Andris Pavenis <andris.pavenis@iki.fi>
- Fixed libstdc++ name for cross-compiler (4.1.1-2)

* Sun May 28 2006 Andris Pavenis <andris.pavenis@iki.fi>
- Updated to GCC-4.1.1 (4.1.1-1)

* Fri Apr  7 2006 Andris Pavenis <andris.pavenis@iki.fi>
- Patched libssp directory to fix problem with generated
  gcc410s.zip. Cross-compiler itself does not change.

* Sat Mar  5 2006 Andris Pavenis <andris.pavenis@iki.fi>
- Bootstrap at first native compiler to be used for building 
  cross-compiler as one need to build cross-compiler with the
  same version of GCC (use of GCC-4.0.2 causes failure in 
  building Ada tools). Updates to DJGPP related patchset.

* Wed Mar  1 2006 Andris Pavenis <andris.pavenis@iki.fi>
- Updated for GCC-4.1.0

* Sun Feb 19 2006 Andris Pavenis <andris.pavenis@iki.fi>
- Added modification of readme.DJGPP according the version of GCC and DJGPP, as
  otherwise it is rather easy to forget to edit it manually when needed

* Mon Nov 15 2005 Andris Pavenis <pavenis@latnet.lv>
- Initial version of rpm spec file for DJGPP cross-compiler
